# C# PDF library to create, edit, draw and print PDF files

![Latest Docotic.Pdf version on NuGet](https://img.shields.io/nuget/vpre/BitMiracle.Docotic.Pdf?logo=nuget&label=Latest%20version) [![Regression tests result](https://img.shields.io/badge/Regression_tests-%E2%9C%93%2014%2C726_passed-34d058?logo=visualstudio)](https://bitmiracle.com/pdf-library/howto/unit-testing) [![Sample code on GitHub](https://img.shields.io/badge/Code_samples-%E2%9C%93%20-107C10?logo=github)](https://github.com/BitMiracle/Docotic.Pdf.Samples)

Docotic.Pdf is the .NET PDF library for .NET Core, ASP.NET, Windows Forms, WPF, Xamarin, Blazor, Unity, and HoloLense applications. 

[Getting started](https://bitmiracle.com/pdf-library/getting-started#using) | [Features](https://bitmiracle.com/pdf-library/help) | [Licensing](https://bitmiracle.com/pdf-library/licenses/) | [Free Trial](https://bitmiracle.com/pdf-library/download)

The library is a 100% managed assembly without unsafe blocks. The assembly has no external dependencies. 

[![Docotic.Pdf library banner](https://raw.githubusercontent.com/BitMiracle/nuget-assets/main/core-readme/docotic.pdf-banner.svg)](https://bitmiracle.com/pdf-library/)

## Features

Use Docotic.Pdf to:
* [Generate PDF documents from containers, images, and text using a modern fluent API](https://bitmiracle.com/pdf-library/layout/). 
* Create PDF documents using [Canvas API](https://github.com/BitMiracle/Docotic.Pdf.Samples/tree/master/Samples/Graphics). 
* [Extract text from PDF documents](https://bitmiracle.com/pdf-library/pdf-text/extract). 
* [Convert HTML to PDF in C#](https://bitmiracle.com/pdf-library/html-pdf/convert) with the help of the HTML to PDF converter add-on.
* [Convert PDF to image](https://bitmiracle.com/pdf-library/pdf-image/convert) and [print PDF documents](https://bitmiracle.com/pdf-library/draw-print-pdf).
* [Compress PDF files](https://bitmiracle.com/pdf-library/optimize/compress).
* [Merge PDF documents](https://bitmiracle.com/pdf-library/edit/merge)
* [Split PDF documents](https://bitmiracle.com/pdf-library/edit/split)
* [Add digital signatures to PDF documents](https://bitmiracle.com/pdf-library/signatures/sign).
* [Encrypt PDF files](https://bitmiracle.com/pdf-library/passwords/encrypt).
* [Remove PDF passwords](https://bitmiracle.com/pdf-library/passwords/decrypt).
* [OCR PDF files](https://bitmiracle.com/blog/ocr-pdf-in-net).
* [Linearize PDF](https://github.com/BitMiracle/Docotic.Pdf.Samples/tree/master/Samples/General%20operations/LinearizeDocument) files. Optimize for Fast Web View.
* [Edit PDF files](https://github.com/BitMiracle/Docotic.Pdf.Samples/tree/master/Samples/Pages%20and%20Navigation/EditPageContent). 


Docotic.Pdf supports .NET 8, .NET 7, .NET 6, .NET 5, .NET Standard / .NET Core, and .NET 4.x frameworks. You can use the library in .NET on Windows, Linux, macOS, Android, and iOS. Works in Azure, AWS and other cloud environments. Can be used from a Docker container.

## Documentation

For documentation, sample code, and API reference, visit [the Docotic.Pdf help page](https://bitmiracle.com/pdf-library/help).

Here are some of the more popular topics:
* [HTML to PDF](https://bitmiracle.com/pdf-library/html-pdf/)
* [PDF to text](https://bitmiracle.com/pdf-library/pdf-text/)
* [PDF to image](https://bitmiracle.com/pdf-library/pdf-image/)
* [Generate PDF](https://bitmiracle/pdf-library/layout/)
* [Edit PDF](https://bitmiracle/pdf-library/edit/)
* [Digital signatures](https://bitmiracle.com/pdf-library/signatures/)
* [Passwords](https://bitmiracle.com/pdf-library/passwords/)
* [How-to articles](https://bitmiracle.com/pdf-library/howto/)

## Add-ons

There are free add-ons to the library:
* [HTML to PDF add-on](https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.HtmlToPdf/)
* [Layout add-on](https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.Layout/)
* [Gdi add-on](https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.Gdi/)
* [Logging add-on](https://www.nuget.org/packages/BitMiracle.Docotic.Pdf.Logging/)

## Licenses

To test the library, get a free time-limited license key using [the form on the Docotic.Pdf page](https://bitmiracle.com/pdf-library/).

Without a license, the library will not create or read PDF documents. 

We offer royalty-free [licenses for Docotic.Pdf](https://bitmiracle.com/pdf-library/licenses/). Eligible projects and/or people can receive [license for the C# PDF library free of payment](https://bitmiracle.com/pdf-library/licenses/free).
